<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseFlightRoute ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseFlightRoute extends AbstractStructArrayBase
{
    /**
     * The Route
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseFlightRoute[]
     */
    public $Route;
    /**
     * Constructor method for ArrayOfJP_CruiseFlightRoute
     * @uses ArrayOfJP_CruiseFlightRoute::setRoute()
     * @param \StructType\JP_CruiseFlightRoute[] $route
     */
    public function __construct(array $route = array())
    {
        $this
            ->setRoute($route);
    }
    /**
     * Get Route value
     * @return \StructType\JP_CruiseFlightRoute[]|null
     */
    public function getRoute()
    {
        return $this->Route;
    }
    /**
     * Set Route value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseFlightRoute[] $route
     * @return \ArrayType\ArrayOfJP_CruiseFlightRoute
     */
    public function setRoute(array $route = array())
    {
        foreach ($route as $arrayOfJP_CruiseFlightRouteRouteItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseFlightRouteRouteItem instanceof \StructType\JP_CruiseFlightRoute) {
                throw new \InvalidArgumentException(sprintf('The Route property can only contain items of \StructType\JP_CruiseFlightRoute, "%s" given', is_object($arrayOfJP_CruiseFlightRouteRouteItem) ? get_class($arrayOfJP_CruiseFlightRouteRouteItem) : gettype($arrayOfJP_CruiseFlightRouteRouteItem)), __LINE__);
            }
        }
        $this->Route = $route;
        return $this;
    }
    /**
     * Add item to Route value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseFlightRoute $item
     * @return \ArrayType\ArrayOfJP_CruiseFlightRoute
     */
    public function addToRoute(\StructType\JP_CruiseFlightRoute $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseFlightRoute) {
            throw new \InvalidArgumentException(sprintf('The Route property can only contain items of \StructType\JP_CruiseFlightRoute, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Route[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseFlightRoute|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseFlightRoute|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseFlightRoute|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseFlightRoute|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseFlightRoute|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Route
     */
    public function getAttributeName()
    {
        return 'Route';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CruiseFlightRoute
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
